diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/GuiModelViewer.java b/src/main/java/net/minecraft/client/gui/modelviewer/GuiModelViewer.java
new file mode 100644
index 000000000..1f154d214
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/GuiModelViewer.java
@@ -0,0 +1,482 @@
+package net.minecraft.client.gui.modelviewer;
+
+import com.b100.utils.ImageUtils;
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiPhotoMode;
+import net.minecraft.client.gui.modelviewer.categories.BlockCategory;
+import net.minecraft.client.gui.modelviewer.categories.EntityCategory;
+import net.minecraft.client.gui.modelviewer.categories.ModelViewerCategory;
+import net.minecraft.client.gui.modelviewer.categories.ParticleCategory;
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerTextField;
+import net.minecraft.client.gui.modelviewer.elements.IListenerElement;
+import net.minecraft.client.gui.options.GuiOptions;
+import net.minecraft.client.gui.options.data.OptionsPages;
+import net.minecraft.client.render.Texture;
+import net.minecraft.client.render.TileEntityRenderDispatcher;
+import net.minecraft.client.render.shader.PhotoModeRenderer;
+import net.minecraft.client.render.shader.Shaders;
+import net.minecraft.client.render.shader.ShadersRenderer;
+import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.client.util.helper.Textures;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.util.helper.Buffer;
+import net.minecraft.core.world.World;
+import org.lwjgl.input.Keyboard;
+import org.lwjgl.input.Mouse;
+import org.lwjgl.opengl.GL11;
+
+import java.io.File;
+import java.nio.ByteBuffer;
+import java.text.DateFormat;
+import java.text.SimpleDateFormat;
+import java.util.ArrayList;
+import java.util.Date;
+import java.util.List;
+import java.util.Locale;
+
+import static org.lwjgl.opengl.GL11.GL_RGBA;
+import static org.lwjgl.opengl.GL11.GL_TEXTURE_2D;
+import static org.lwjgl.opengl.GL11.GL_TEXTURE_HEIGHT;
+import static org.lwjgl.opengl.GL11.GL_TEXTURE_WIDTH;
+import static org.lwjgl.opengl.GL11.GL_UNSIGNED_BYTE;
+import static org.lwjgl.opengl.GL11.glGetError;
+import static org.lwjgl.opengl.GL11.glGetTexImage;
+import static org.lwjgl.opengl.GL11.glGetTexLevelParameteri;
+
+public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField.ITextChangeListener {
+    private GuiListenerButton buttonRotateLeft;
+    private GuiListenerButton buttonRotateRight;
+    private GuiListenerButton buttonCenterScreen;
+    private GuiListenerButton buttonTakeScreenshot;
+    private GuiListenerButton buttonExit;
+    private GuiListenerSlider sliderTilt;
+    private GuiListenerButton buttonShaders;
+    private GuiListenerSlider sliderIntensity;
+    public GuiListenerButton buttonPrevEntry;
+    public GuiListenerButton buttonNextEntry;
+    private GuiListenerButton buttonCategory;
+    private GuiListenerButton buttonReloadTextures;
+    private GuiListenerButton buttonTickToggle;
+    private final ModelViewerCategory entityCategory = new EntityCategory(this);
+    private final ModelViewerCategory particleCategory = new ParticleCategory(this);
+    private final ModelViewerCategory blockCategory = new BlockCategory(this);
+    public final List<ModelViewerCategory> categories = new ArrayList<>();
+    private ModelViewerCategory currentCategory;
+    protected final int defaultRed = (int) (255 * 0.25f);
+    protected final int defaultGreen = (int) (255 * 0.25f);
+    protected final int defaultBlue = (int) (255 * 0.35f);
+    protected int bgRed = defaultRed;
+    protected int bgGreen = defaultGreen;
+    protected int bgBlue = defaultBlue;
+
+    protected boolean tickProgress = true;
+    protected boolean rotateToCamera = true;
+    public GuiModelViewer(){
+        this.mc = Minecraft.getMinecraft(this);
+        mc.thePlayer.absMoveTo(0.5, 64.5, 0.5, 180, 0);
+        mc.thePlayer.noPhysics = true;
+        mc.renderEngine.refreshTexturesAndDisplayErrors();
+        mc.renderEngine.updateDynamicTextures();
+
+        if(Shaders.enableShaders) {
+            photoModeRenderer = new PhotoModeRenderer(mc, this);
+        }
+
+        this.previousRenderer = mc.render;
+        showPlayer = false;
+        showHelpText = false;
+        lastIZoom = iZoom = iZoomGoal = 8.5f;
+
+        mc.ppm.reset();
+
+        iRotationGoal = iRotation = -2;
+
+        categories.add(blockCategory);
+        categories.add(entityCategory);
+        categories.add(particleCategory);
+        setCategory(entityCategory);
+    }
+    @Override
+    public void init()
+    {
+        controlList.clear();
+        I18n i18n = I18n.getInstance();
+
+        List<GuiButton> leftSideButtons = new ArrayList<>();
+
+        buttonExit = new GuiListenerButton(5, 0, height - 20, 20, 20, "X");
+        buttonExit.setActionListener(this::exitToMenu);
+
+        buttonRotateLeft = new GuiListenerButton(0, width / 2 - 49 - 2 - 20, height - 20, 20, 20, "<");
+        buttonRotateLeft.setActionListener(() -> {
+            iRotationGoal += 1;
+            iRotationGoal = (int) iRotationGoal;
+        });
+        buttonRotateRight = new GuiListenerButton(1, width / 2 + 49 + 2, height - 20, 20, 20, ">");
+        buttonRotateRight.setActionListener(() -> {
+            iRotationGoal -= 1;
+            iRotationGoal = (int) iRotationGoal;
+        });
+        buttonTakeScreenshot = new GuiListenerButton(4, width / 2 - 49, height - 20, 98, 20, i18n.translateKey("gui.photo_mode.button.take_screenshot"));
+        buttonTakeScreenshot.setActionListener(this::screenShot);
+
+        buttonPrevEntry = new GuiListenerButton(10, width / 2 - 49 - 2 - 20, height - 40 - 2, 20, 20, "<");
+        buttonPrevEntry.setActionListener(() -> currentCategory.cycleCategoryEntry(-1));
+        buttonNextEntry = new GuiListenerButton(11, width / 2 + 49 + 2, height - 40 - 2, 20, 20, ">");
+        buttonNextEntry.setActionListener(() -> currentCategory.cycleCategoryEntry(1));
+        buttonCategory = new GuiListenerButton(12, width / 2 - 49, height - 40 - 2, 98, 20, i18n.translateKey(currentCategory.getCategoryNameKey()));
+        buttonCategory.setActionListener(() -> setCategory(categories.get((categories.indexOf(currentCategory) + 1) % categories.size())));
+        buttonCategory.setOnValueChanged(() -> buttonCategory.displayString = i18n.translateKey(currentCategory.getCategoryNameKey()));
+
+        buttonReloadTextures = new GuiListenerButton(12, 21, height - 20, 98, 20, i18n.translateKey("gui.model_viewer.button.reload_textures"));
+        buttonReloadTextures.setActionListener(() -> mc.renderEngine.refreshTexturesAndDisplayErrors());
+
+        buttonCenterScreen = new GuiListenerButton(10, 0, 0, 120, 20, i18n.translateKey("gui.photo_mode.button.center_camera"));
+        buttonCenterScreen.setActionListener(() -> {
+            iPanXGoal = 0;
+            iPanYGoal = 0;
+        });
+
+        buttonTickToggle = new GuiListenerButton(13, width - 120, 0, 99, 20, i18n.translateKeyAndFormat("gui.model_viewer.button.tickprogress", tickProgress));
+        buttonTickToggle.setActionListener(() -> tickProgress = !tickProgress);
+        buttonTickToggle.setOnValueChanged(() -> buttonTickToggle.displayString = i18n.translateKeyAndFormat("gui.model_viewer.button.tickprogress", tickProgress));
+
+        GuiListenerButton cameraRotateButton = new GuiListenerButton(-1, width - 120, 0, 120, 20, i18n.translateKeyAndFormat("gui.model_viewer.button.rotate", rotateToCamera));
+        cameraRotateButton.setActionListener(() -> {
+            rotateToCamera = !rotateToCamera;
+            cameraRotateButton.displayString = i18n.translateKeyAndFormat("gui.model_viewer.button.rotate", rotateToCamera);
+        });
+
+        GuiListenerButton buttonManualTick = new GuiListenerButton(14, width - 21, 0, 20, 20, "+");
+        buttonManualTick.setActionListener(this::entryTick);
+
+        sliderTilt = new GuiListenerSlider(7, 0, 0, 120, 20, i18n.translateKey("gui.photo_mode.button.tilt.default"), iTiltGoal / 90f);
+        sliderTilt.setOnValueChanged(() ->{
+            // Update tilt slider
+            String tilt = i18n.translateKey("gui.photo_mode.button.tilt.default");
+            if ((int)(sliderTilt.sliderValue * 90.0f) != 30)
+            {
+                tilt = (int)(sliderTilt.sliderValue * 90.0f) + " degrees";
+            }
+            sliderTilt.displayString = i18n.translateKeyAndFormat("gui.photo_mode.button.tilt", tilt);
+            if (sliderTilt.dragging)
+            {
+                iTiltGoal = (float) (int)(sliderTilt.sliderValue * 90.0f);
+            }
+        });
+        if(Shaders.enableShaders) {
+            buttonShaders = new GuiListenerButton(8, 0, 0, 120, 20, i18n.translateKeyAndFormat("gui.photo_mode.button.shader", i18n.translateKey("gui.photo_mode.button.shader.none")));
+            buttonShaders.setActionListener(() -> {
+                boolean ctrl = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL);
+                if (ctrl)
+                {
+                    photoModeRenderer.first();
+                }
+                else
+                {
+                    photoModeRenderer.next();
+                }
+                sliderIntensity.enabled = photoModeRenderer.getActiveShader() != null;
+            });
+            buttonShaders.setOnValueChanged(() -> {
+                String activeShader = photoModeRenderer.getActiveShader();
+                if (activeShader == null) activeShader = i18n.translateKey("gui.photo_mode.button.shader.none");
+                activeShader = activeShader.toUpperCase(Locale.ROOT);
+                buttonShaders.displayString = i18n.translateKeyAndFormat("gui.photo_mode.button.shader", activeShader);
+            });
+            sliderIntensity = new GuiListenerSlider(9, 0, 0, 120, 20, i18n.translateKeyAndFormat("gui.photo_mode.button.intensity", (int)(intensityValue * 100) + "%"), intensityValue);
+            sliderIntensity.setOnValueChanged(() ->{
+                // Update intensity slider
+                sliderIntensity.displayString = i18n.translateKeyAndFormat("gui.photo_mode.button.intensity", (int)(sliderIntensity.sliderValue * 100) + "%");
+                if (sliderIntensity.dragging) {
+                    intensityValue = sliderIntensity.sliderValue;
+                }
+            });
+
+            if (photoModeRenderer.getActiveShader() == null) {
+                sliderIntensity.enabled = false;
+            }
+        }
+
+        if(Shaders.enableShaders) {
+            mc.setRenderer(photoModeRenderer);
+        }
+
+        controlList.add(cameraRotateButton);
+        controlList.add(buttonTickToggle);
+
+        int i=0;
+        List<GuiButton> _buttons = new ArrayList<>(controlList);
+        for(GuiButton button : _buttons) {
+            button.yPosition = i++ * 21;
+        }
+
+        controlList.add(buttonManualTick);
+        buttonManualTick.yPosition = buttonTickToggle.yPosition;
+
+        currentCategory.addContextButtons(controlList);
+
+        leftSideButtons.add(buttonCenterScreen);
+        leftSideButtons.add(sliderTilt);
+
+        if(Shaders.enableShaders) {
+            leftSideButtons.add(buttonShaders);
+            leftSideButtons.add(sliderIntensity);
+        }
+
+        int j = 0;
+        for (GuiButton button: leftSideButtons){
+            button.yPosition = j++ * 21;
+        }
+
+        controlList.addAll(leftSideButtons);
+
+        GuiListenerTextField rField = new GuiListenerTextField(this, fontRenderer, 0, j++ * 21, 40, 20, String.valueOf(bgRed), "Red");
+        rField.setPrefaceText("R: ");
+        rField.setKeyListener(key -> {
+            try {
+                bgRed = Integer.parseInt(rField.getText());
+            } catch (Exception ignored){}
+        });
+        rField.setActionListener(() -> {
+            if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL)){
+                rField.setText(String.valueOf(defaultRed));
+                bgRed = defaultRed;
+            }
+        });
+        GuiListenerTextField gField = new GuiListenerTextField(this, fontRenderer, 40, rField.yPosition, 40, 20, String.valueOf(bgGreen), "Green");
+        gField.setPrefaceText("G: ");
+        gField.setKeyListener(key -> {
+            try {
+                bgGreen = Integer.parseInt(gField.getText());
+            } catch (Exception ignored){}
+        });
+        gField.setActionListener(() -> {
+            if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL)){
+                gField.setText(String.valueOf(defaultGreen));
+                bgGreen = defaultGreen;
+            }
+        });
+        GuiListenerTextField bField = new GuiListenerTextField(this, fontRenderer, 80, rField.yPosition, 40, 20, String.valueOf(bgBlue), "Blue");
+        bField.setPrefaceText("B: ");
+        bField.setKeyListener(key -> {
+            try {
+                bgBlue = Integer.parseInt(bField.getText());
+            } catch (Exception ignored){}
+        });
+        bField.setActionListener(() -> {
+            if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL)){
+                bField.setText(String.valueOf(defaultBlue));
+                bgBlue = defaultBlue;
+            }
+        });
+
+        controlList.add(rField);
+        controlList.add(gField);
+        controlList.add(bField);
+
+        controlList.add(buttonRotateLeft);
+        controlList.add(buttonRotateRight);
+        controlList.add(buttonTakeScreenshot);
+        controlList.add(buttonPrevEntry);
+        controlList.add(buttonNextEntry);
+        controlList.add(buttonCategory);
+        controlList.add(buttonReloadTextures);
+        controlList.add(buttonExit);
+    }
+    private void setCategory(ModelViewerCategory category){
+        if (currentCategory != null){
+            currentCategory.onClose();
+        }
+        currentCategory = category;
+        if (currentCategory != null){
+            currentCategory.onOpen();
+        }
+        init();
+    }
+    public static int cycleItemId(int itemId, int offset){
+        int id = (itemId + Item.itemsList.length + offset) % Item.itemsList.length;
+        while (Item.itemsList[id] == null){
+            id = (id + (int) Math.signum(offset) + Item.itemsList.length) % Item.itemsList.length;
+        }
+        return id;
+    }
+    @Override
+    public void drawScreen(int mouseX, int mouseY, float partialTick)
+    {
+        GL11.glViewport(0, 0, mc.resolution.width, mc.resolution.height);
+        GL11.glMatrixMode(GL11.GL_PROJECTION);
+        GL11.glLoadIdentity();
+        GL11.glMatrixMode(GL11.GL_MODELVIEW /*GL_MODELVIEW0_ARB*/);
+        GL11.glLoadIdentity();
+        GL11.glClear(256);
+        GL11.glMatrixMode(GL11.GL_PROJECTION);
+        GL11.glLoadIdentity();
+        GL11.glOrtho(0.0D, mc.resolution.scaledWidth, mc.resolution.scaledHeight, 0.0D, 1000D, 3000D);
+        GL11.glMatrixMode(GL11.GL_MODELVIEW /*GL_MODELVIEW0_ARB*/);
+        GL11.glLoadIdentity();
+        GL11.glTranslatef(0.0F, 0.0F, -2000F);
+
+        if (rotateToCamera){
+            mc.thePlayer.yRotO = mc.thePlayer.yRot = getRotation(partialTick) * 45f - 135f;
+        } else {
+            mc.thePlayer.yRotO = mc.thePlayer.yRot = 180;
+        }
+
+        lastIZoom = iZoom;
+        if (iZoom != iZoomGoal)
+        {
+            iZoom += (iZoomGoal - iZoom) * 0.08f;
+            if (Math.abs(iZoom - iZoomGoal) < 0.0005f) iZoom = iZoomGoal;
+        }
+
+        lastIRotation = iRotation;
+        if (iRotation != iRotationGoal)
+        {
+            iRotation += (iRotationGoal - iRotation) * 0.08f;
+            if (Math.abs(iRotation - iRotationGoal) < 0.0005f) iRotation = iRotationGoal;
+        }
+
+        lastITilt = iTilt;
+        if (iTilt != iTiltGoal)
+        {
+            iTilt += (iTiltGoal - iTilt) * 0.08f;
+            if (Math.abs(iTilt - iTiltGoal) < 0.01f) iTilt = iTiltGoal;
+        }
+
+        lastIPanX = iPanX;
+        if (iPanX != iPanXGoal)
+        {
+            iPanX += (iPanXGoal - iPanX) * 0.4f;
+            if (Math.abs(iPanX - iPanXGoal) < 0.01f) iPanX = iPanXGoal;
+        }
+
+        lastIPanY = iPanY;
+        if (iPanY != iPanYGoal)
+        {
+            iPanY += (iPanYGoal - iPanY) * 0.4f;
+            if (Math.abs(iPanY - iPanYGoal) < 0.01f) iPanY = iPanYGoal;
+        }
+
+        buttonCenterScreen.enabled = (iPanX != 0 || iPanY != 0) && !(iPanXGoal == 0 && iPanYGoal == 0);
+
+        List<GuiButton> _buttons = new ArrayList<>(controlList);
+        for (GuiButton guibutton : _buttons) {
+            guibutton.drawButton(mc, mouseX, mouseY);
+        }
+
+        scroll(Mouse.getDWheel());
+
+        TileEntityRenderDispatcher.instance.renderTileEntity(TessellatorStandard.instance, new TileEntity(), -0.5D, -0.75D, -0.5D, partialTick);
+
+        drawStringCentered(fontRenderer, currentCategory.getCurrentDisplayInfo(I18n.getInstance()), width/2, 1, 0xffffff);
+    }
+    @Override
+    public void keyTyped(char c, int key, int mouseX, int mouseY)
+    {
+        if (key == Keyboard.KEY_ESCAPE) {
+            exitToMenu();
+        }
+        List<GuiButton> _buttons = new ArrayList<>(controlList);
+        for (GuiButton button : _buttons){
+            if (button instanceof IListenerElement && button.isHovered(mouseX, mouseY)){
+                ((IListenerElement) button).onKeyTyped(c, key);
+            }
+        }
+    }
+    private void exitToMenu(){
+        currentCategory.onClose();
+        mc.changeWorld(null);
+        mc.displayGuiScreen(new GuiOptions(null, OptionsPages.DEBUG));
+    }
+    public static int cycleBlockId(int id, int idOff){
+        int id2 = (id + Block.blocksList.length + idOff) % Block.blocksList.length;
+        while (Block.blocksList[id2] == null){
+            id2 = (id2 + (int) Math.signum(idOff) + Block.blocksList.length) % Block.blocksList.length;
+        }
+        return id2;
+    }
+    @Override
+    public void onClosed() {
+        if(Shaders.enableShaders) {
+            mc.setRenderer(previousRenderer);
+        }
+        Minecraft.doPartialTick = true;
+    }
+    @Override
+    public void tick()
+    {
+        super.tick();
+        List<GuiButton> _buttons = new ArrayList<>(controlList);
+        for (GuiButton button : _buttons){
+            if (button instanceof GuiListenerButton){
+                ((GuiListenerButton) button).tick();
+            }
+        }
+        if (tickProgress){
+            entryTick();
+        }
+        Minecraft.doPartialTick = tickProgress;
+    }
+    private void entryTick(){
+        mc.renderEngine.updateDynamicTextures();
+        mc.effectRenderer.updateEffects();
+        currentCategory.onTick();
+        // TODO this fixes world time based animation, but also ticks things like wind and im not certain on the best way to set wind direction arbitrarily right now
+//        mc.theWorld.getLevelData().setWorldTime(mc.theWorld.getWorldTime() + 1);
+    }
+    @Override
+    protected void buttonPressed(GuiButton button) {
+        // Overrides the regular GuiPhotomode's method
+    }
+
+    public long timeLastKeyPressed = System.currentTimeMillis();
+    @Override
+    public void textChanged(GuiListenerTextField textField) {
+        timeLastKeyPressed = System.currentTimeMillis();
+    }
+    public float[] getBackgroundFogColor(){
+        return new float[]{bgRed/255f, bgGreen/255f, bgBlue/255f};
+    }
+    private static final DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd_HH.mm.ss");
+    public void screenShot(){
+        try {
+            File screenshotsDir = new File(mc.getMinecraftDir(), "screenshots");
+            screenshotsDir.mkdir();
+            Texture texture = ((ShadersRenderer)mc.render).getWorldFramebufferTex();
+            texture.bind();
+
+            int w = glGetTexLevelParameteri(GL_TEXTURE_2D, 0, GL_TEXTURE_WIDTH);
+            int h = glGetTexLevelParameteri(GL_TEXTURE_2D, 0, GL_TEXTURE_HEIGHT);
+
+            int size = w * h * 4;
+            Buffer.checkBufferSize(size);
+            ByteBuffer buffer = Buffer.buffer;
+
+            buffer.position(0).limit(size);
+            glGetTexImage(GL_TEXTURE_2D, 0, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
+            if(glGetError() == 0) {
+                buffer.position(0);
+                File outPut;
+                String timeStamp = "Render_" + dateFormat.format(new Date());
+                int id = 1;
+                while ((outPut = new File(screenshotsDir, timeStamp + (id != 1 ? "_" + id : "") + ".png")).exists()) {
+                    id++;
+                }
+                ImageUtils.saveExternalImage(Textures.getImage(buffer, w, h, true, true), outPut);
+
+            }else {
+                System.out.println("Cannot get pixel data");
+            }
+        } catch (Exception e){
+            e.printStackTrace();
+        }
+    }
+
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/BlockCategory.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/BlockCategory.java
new file mode 100644
index 000000000..d699db98a
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/BlockCategory.java
@@ -0,0 +1,203 @@
+package net.minecraft.client.gui.modelviewer.categories;
+
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.modelviewer.GuiModelViewer;
+import net.minecraft.client.gui.modelviewer.categories.entries.block.BasicBlockEntry;
+import net.minecraft.client.gui.modelviewer.categories.entries.block.BlockEntry;
+import net.minecraft.client.gui.modelviewer.categories.entries.block.JarEntry;
+import net.minecraft.client.gui.modelviewer.categories.entries.block.MobSpawnerEntry;
+import net.minecraft.client.gui.modelviewer.categories.entries.block.SignEntry;
+import net.minecraft.client.gui.modelviewer.elements.GuiTextCycle;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.chunk.DisplayChunk;
+
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+
+public class BlockCategory extends ModelViewerCategory {
+    public List<GuiButton> buttonBuffer = new ArrayList<>();
+    public HashMap<Block, BlockEntry> entryHashMap = new HashMap<>();
+    public GuiTextCycle<Integer> blockIdTextField;
+    public GuiTextCycle<Integer> blockMetaTextField;
+    public BlockCategory(GuiModelViewer modelViewer) {
+        super(modelViewer);
+        createEntries();
+    }
+    public void createEntries(){
+        for (Block block : Block.blocksList){
+            if (block == null) continue;
+            entryHashMap.put(block, new BasicBlockEntry(block));
+        }
+        entryHashMap.put(Block.signWallPlanksOak, new SignEntry(Block.signWallPlanksOak));
+        entryHashMap.put(Block.signPostPlanksOak, new SignEntry(Block.signPostPlanksOak));
+        entryHashMap.put(Block.mobspawner, new MobSpawnerEntry());
+        entryHashMap.put(Block.jarGlass, new JarEntry());
+    }
+
+    @Override
+    public String getCategoryNameKey() {
+        return "model.category.block.name";
+    }
+
+    @Override
+    public String getCurrentDisplayInfo(I18n translator) {
+        Block displayBlock = Block.getBlock(DisplayChunk.displayBlockId);
+        String name = "None";
+        if (displayBlock != null){
+            name = I18n.getInstance().translateNameKey(displayBlock.getKey());
+            ItemStack[] nameStack = displayBlock.getBreakResult(mc.theWorld, EnumDropCause.PICK_BLOCK, DisplayChunk.displayBlockPosX, DisplayChunk.displayBlockPosY, DisplayChunk.displayBlockPosZ, DisplayChunk.displayBlockMeta, DisplayChunk.displayTileEntity);
+            if (nameStack != null && nameStack.length > 0){
+                name = nameStack[0].getDisplayName();
+            }
+        }
+        return translator.translateKeyAndFormat("model.category.block.info", name);
+    }
+
+    @Override
+    public void addContextButtons(List<GuiButton> buttonList) {
+        GuiButton lastButton = buttonList.get(buttonList.size()-1);
+        buttonBuffer.clear();
+
+        modelViewer.buttonNextEntry.enabled = false;
+        modelViewer.buttonPrevEntry.enabled = false;
+
+        boolean wasFocused = false;
+        if (blockIdTextField != null){
+            wasFocused = blockIdTextField.textField.isFocused;
+        }
+        blockIdTextField = new GuiTextCycle<Integer>(modelViewer, mc.fontRenderer, modelViewer.width - 120, lastButton.yPosition + 21, 120, 20, DisplayChunk.displayBlockId) {
+            @Override
+            public Integer cycleElement(Integer current, int offset) {
+                return GuiModelViewer.cycleBlockId(current, offset);
+            }
+
+            @Override
+            public Integer getElementFromString(String s) {
+                try {
+                    int id = MathHelper.clamp(Integer.parseInt(s), 0, Block.blocksList.length);
+                    if (Block.getBlock(id) != null){
+                        return id;
+                    }
+                } catch (Exception ignored){}
+                return DisplayChunk.displayBlockId;
+            }
+
+            @Override
+            public String getNameFromElement(Integer element) {
+                return String.valueOf(element);
+            }
+        };
+        blockIdTextField.textField.setFocused(wasFocused);
+        blockIdTextField.textField.setPrefaceText("ID: ");
+        blockIdTextField.textField.setPlaceholder("Block ID");
+        blockIdTextField.setOnValueChanged(() -> setDisplayBlock(blockIdTextField.getCurrentElement(), 0));
+
+        buttonList.add(blockIdTextField);
+
+        wasFocused = false;
+        if (blockMetaTextField != null){
+            wasFocused = blockMetaTextField.textField.isFocused;
+        }
+        blockMetaTextField = new GuiTextCycle<Integer>(modelViewer, mc.fontRenderer, modelViewer.width - 120, blockIdTextField.yPosition + 21, 120, 20, 0) {
+            @Override
+            public Integer cycleElement(Integer current, int offset) {
+                return (current + offset) & 0xFF;
+            }
+
+            @Override
+            public Integer getElementFromString(String s) {
+                try {
+                    int meta = Integer.parseInt(s);
+                    return MathHelper.clamp(meta, 0, 255);
+                } catch (Exception ignored){}
+                return DisplayChunk.displayBlockMeta;
+            }
+
+            @Override
+            public String getNameFromElement(Integer element) {
+                return String.valueOf(element);
+            }
+        };
+        blockMetaTextField.textField.setFocused(wasFocused);
+        blockMetaTextField.textField.setPlaceholder("Meta");
+        blockMetaTextField.textField.setPrefaceText("Meta: ");
+        blockMetaTextField.setOnValueChanged(() -> setDisplayBlock(DisplayChunk.displayBlockId, blockMetaTextField.getCurrentElement()));
+        buttonList.add(blockMetaTextField);
+
+        int yPos = blockMetaTextField.yPosition + 21;
+        int xPos = modelViewer.width;
+
+        BlockEntry entry = entryHashMap.get(Block.getBlock(DisplayChunk.displayBlockId));
+
+        if (entry != null){
+            List<GuiButton> list = entry.getEntryButtons(mc, modelViewer, mc.theWorld, DisplayChunk.displayBlockMeta);
+            if (list != null){
+                for (GuiButton button : list) {
+                    button.setX(button.getX() + xPos);
+                    button.setY(button.getY() + yPos);
+                }
+                buttonList.addAll(list);
+            }
+        }
+    }
+
+    @Override
+    public void cycleCategoryEntry(int offset) {
+
+    }
+
+    @Override
+    public void onOpen() {
+        setDisplayBlock(1, 0);
+    }
+
+    @Override
+    public void onClose() {
+        setDisplayBlock(0, 0);
+    }
+
+    @Override
+    public void onTick() {
+        BlockEntry entry = entryHashMap.get(Block.getBlock(DisplayChunk.displayBlockId));
+        if (entry != null){
+            entry.onTick(mc.theWorld, DisplayChunk.displayBlockMeta);
+        }
+        // Delete any items blocks create when added/removed
+        mc.theWorld.loadedEntityList.removeIf(entity -> entity instanceof EntityItem);
+    }
+    public void setDisplayBlock(int id, int meta){
+        Block displayBlock = Block.blocksList[DisplayChunk.displayBlockId];
+        BlockEntry entry = entryHashMap.get(Block.getBlock(DisplayChunk.displayBlockId));
+        int _id = DisplayChunk.displayBlockId;
+        int _meta = DisplayChunk.displayBlockMeta;
+
+        if (displayBlock != null && _id != id){
+            displayBlock.onBlockRemoved(mc.theWorld, (int) mc.thePlayer.x, (int) mc.thePlayer.y, (int) mc.thePlayer.z, _meta);
+        }
+        if (entry != null){
+            entry.onClose(mc.theWorld, DisplayChunk.displayBlockMeta);
+        }
+        DisplayChunk.displayBlockPosX = (int) mc.thePlayer.x;
+        DisplayChunk.displayBlockPosY = (int) mc.thePlayer.y;
+        DisplayChunk.displayBlockPosZ = (int) mc.thePlayer.z;
+        DisplayChunk.displayBlockId = id;
+        DisplayChunk.displayBlockMeta = meta;
+        displayBlock = Block.blocksList[id];
+        if (displayBlock != null && _id != id){
+            entry = entryHashMap.get(Block.getBlock(DisplayChunk.displayBlockId));
+            displayBlock.onBlockAdded(mc.theWorld, (int) mc.thePlayer.x, (int) mc.thePlayer.y, (int) mc.thePlayer.z);
+            if (entry != null) entry.onOpen(mc.theWorld, DisplayChunk.displayBlockMeta);
+        }
+        if (_id != id){
+            modelViewer.init();
+        }
+        mc.effectRenderer.clearEffects(mc.theWorld);
+        mc.renderGlobal.loadRenderers();
+    }
+}
